#include <iostream.h>
#include "base.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <qlist.h> 
#include <qapplication.h> 
#include "qfiledialog.h" 



Base::Base(){i=0;}

Base::~Base(){}
void Base::inserer(Ville* p)
{ v.inserer(p);

}

bool Base::supprimer(Ville *p)
{
  
  p->sauve_defaire(0);
  QList<Route> L;
  L=p->retVoisins();
  Route * rout=L.first();


  // Liste de routes pour sauver celles de la ville  effacer :
  QList<Route> undo_routes;

if (!(L.isEmpty()))
  {while(rout!=NULL)
    { // On sauve les routes de la ville avant de les effacer de la Base de Donnes.
      Route *RR = new Route();
      (*RR)=(*rout);
      undo_routes.append(RR);

      supprimer2(rout);
      rout=L.next();}
  }

 // On remet les routes dans la ville efface (pour defaire) :
 rout=undo_routes.first();
 while(rout!=NULL)
   {
     p->ajoutVoisin(rout);
     if ((rout->retextrem1())==p) rout->modextrem1(NULL);
     else rout->modextrem2(NULL);
     rout=undo_routes.next();
   }

 return v.supprimer(p);
}

void Base::inserer(Route* p)
{ r.inserer(p);

}

bool Base::supprimer(Route* p)
{
  p->sauve_defaire(0);
  p->retextrem1()->suppriVoisin(p);
  p->retextrem2()->suppriVoisin(p);
  return r.supprimer(p);
}

bool Base::supprimer2(Route* p)
{
  p->retextrem1()->suppriVoisin(p);
  p->retextrem2()->suppriVoisin(p);
  return r.supprimer(p);
}


void Base::lier()
{i=i+1;}


void Base::delier()
{i=i-1;
if (i<=0) this->~Base();}


Ville* Base:: premVille() const
{return v.tete();}

Ville* Base:: villeSuiv(Ville* p) const
{return v.Suivant(p);}

Route* Base:: premRoute() const
{return r.tete();}

Route* Base:: routeSuiv(Route* p) const
{return r.Suivant(p);}



bool Base::Sauver(const char *fich)
{
  //QApplication *g=new QApplication (0,0);
  //QString fich=QFileDialog::getSaveFileName( 0, 0, 0,"coucou" );
int descript=open(fich , O_WRONLY|O_CREAT|O_TRUNC,S_IRWXU|S_IRWXG);
 if (!(v.Sauve(descript))) {close(descript);return false;}
 char * mot="";
 for (int i=0;i<4;i++)
   {if (write(descript,&mot[i],1)==-1) {close(descript);return false;}
   } 
 char ret='\n';
 if (write(descript,&ret,1)==-1) {close(descript);return false;}
 if (!(r.Sauve(descript))) {close(descript);return false;}
 else {close(descript);return true;}
}

bool Base::Restituer(const char * fic)
{//QApplication *gg=new QApplication (0,0);
  // QString fic=QFileDialog::getOpenFileName( 0, 0, 0,"coucou2" );
 Vider();
 int descri=open(fic , O_RDONLY);
 Ville *VIL;
 Route* ROU;
 char U;
 long g;
 QString mot;
 deb:
 mot="";
 for (int k=0;k<4;k++)
     {if (read(descri,&U,1)<=0) {close(descri);return false;}
      mot=mot+U;     
     }
 if (mot!="")
   {g=lseek(descri,-4,SEEK_CUR);
    VIL=new Ville;
    if (!VIL->restitRoutVille(descri)) {close(descri);return false;}
    inserer(VIL);
    goto deb;
   }
 else {
 while(read(descri,&U,1)>0)
  {ROU=new Route;
   if (!ROU->restitRoutVille(descri,this)) {close(descri);return false;}
   inserer(ROU);
  }
 if (read(descri,&U,1)==-1) {close(descri);return false;} 
       }
 close(descri);
 return true;
}


void Base::Vider()
{v.ViderE();
 r.ViderE();
}

Ville* Base::rechxy(uniteCoor a, uniteCoor b)
{Ville* P=v.tete();
 while(P!=NULL)
   {if ((a==P->retx()) && (b==P->rety())) return P;
    P=v.Suivant(P);
   }
 return NULL;
}



