#ifndef BASE_H
#define BASE_H
#include "ens.h"
#include <qlist.h>
#include <qstring.h>

class Route;

class Base
{
 private:
ENS<Route> r;
ENS<Ville> v;
int i;
bool verifier;

 public:

Base();
virtual ~Base();
virtual void recherche();
virtual void inserer(Ville*);
virtual bool supprimer(Ville*);
virtual void inserer(Route*);
virtual bool supprimer(Route*);
virtual void lier();
virtual void delier();
virtual Ville* premVille() const;
virtual Ville* villeSuiv(Ville*) const;
virtual Route* premRoute() const;
virtual Route* routeSuiv(Route*) const;
virtual bool Sauver(const char*);
virtual bool Restituer(const char*);
virtual void Vider();
virtual Ville* rechxy(uniteCoor, uniteCoor);
virtual QList<Ville> rech_x(uniteCoor);
virtual QList<Ville> rech_y(uniteCoor,QList<Ville>);
virtual QList<Ville> rech_nom(QString,QList<Ville>);
virtual QList<Ville> rech_altmin(int,QList<Ville>);
virtual QList<Ville> rech_altmax(int,QList<Ville>);
virtual QList<Ville> rech_habmin(long,QList<Ville>);
virtual QList<Ville> rech_habmax(long,QList<Ville>);
virtual QList<Ville> rech_region(QString,QList<Ville>);
virtual QList<Ville> rech_vil_type(int,QList<Ville>);
virtual bool appartienttyp(int,char);
virtual QList<Ville> recherchev(int,QString,int,int,long,long,QString,uniteCoor,uniteCoor);

virtual void defaire();
virtual void refaire();
virtual bool supprimer2(Route *);


};

#endif
