#ifndef DIALOGS_H
#define DIALOGS_H

#include <qdialog.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qcombobox.h>

#include "ville.h"
#include "route.h"

class DEditRoute : public QDialog {
  Q_OBJECT

 public:
  DEditRoute(Route *,QWidget *parent=0, const char *name=0);
  ~DEditRoute();
  static bool edition(Route *);

 private slots:
  void check_data();

 private:
  Route* r;
  
  QLabel *l_nom,*l_longueur,*l_type;
  QLineEdit *ed_nom,*ed_longueur;
  QGroupBox *g_route;
  QComboBox *c_type;
  QPushButton *ok,*cancel;
  
  
};

class DEditVille : public QDialog{
Q_OBJECT

public:
  DEditVille(Ville *,QWidget *parent=0, const char *name=0);
  ~DEditVille();
  static bool edition(Ville *);

 private slots:
  void check_data();

 private:
  Ville* v;
  
  QLabel *l_nom,*l_population,*l_altitude,*l_region,*l_type;
  QLineEdit *ed_nom,*ed_population,*ed_altitude,*ed_region,*ed_type;
  QGroupBox *g_ville;
  QComboBox *c_type;
  QPushButton *ok,*cancel;
  
  
};

#endif
  
  
  
  
