#include <iostream.h>
#include "ens.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <qlist.h>



template<class type>
ENS<type>::ENS() { }

template<class type>
ENS<type>::~ENS() {}

template<class type>
int ENS<type>::hash(QString nom, int tailleTab) const
{int i=0;
 for (int j=0; j<nom.length(); j++)i+=(j+1)*nom[j];
 return (i % tailleTab);}


template<class type>
void ENS<type>::inserer(type*t)
{int h=hash(t->rethash(),taille);
 Tab[h].ajoutApres(Tab[h].premier() , t) ;}

template<class type>
bool ENS<type>::supprimer(type * t)
{int h=hash(t->rethash(),taille);
 Place p=Tab[h].recherche(t);
 if (p==NULL) {return false;}
 else {Tab[h].enleve(p);
       //delete t;
       return true;}
}

template<class type>
type* ENS<type>::tete() const
{for(int i=0;i<taille;i++)
  {if (Tab[i].premier()!=NULL) return Tab[i].valeur(Tab[i].premier());}
 return NULL;}

template<class type>
type* ENS<type>::Suivant(type* el) const
{int h=hash(el->rethash(),taille);
Place p=Tab[h].recherche(el);
if (p==NULL) return NULL;
else if (Tab[h].suivant(p)!=NULL) return Tab[h].valeur(Tab[h].suivant(p)) ;
     else {h=h+1;
           while ((h<taille) && (Tab[h].videP()))
		 {h=h+1;}
          if (h==taille) return NULL;
          else return Tab[h].valeur(Tab[h].premier());}
}

template<class type>
int ENS<type>::Taille() const
{int S=0;
for (int i=0;i<taille;i++)
  {S=S+Tab[i].longueur();}
 return S;}



template<class type>
bool ENS<type>::Sauve(int descr)
{if (tete()==NULL) {return false;}
 type* P=tete();
  while (P!=NULL)
   {if (!(P->sauveRoutVille(descr))) {return false;}
    char ret='\n';
    write(descr,&ret,1);
    P=Suivant(P);}
 return true;
} 
 
template<class type>
void ENS<type>::ViderE()
{for (int i=0;i<taille;i++)
  {Tab[i].raz();}
}






