#ifndef ensemble_h
#define ensemble_h
#include "tLidou.h"
#include "route.h"
#include "ville.h"
#include <qlist.h>



#define taille 20  //Afin de pouvoir modifier la taille du tableau .

template<class type>


class ENS
{
  private :

    ListeDouble<type*> Tab[taille] ; // C'est un tableau de listes doubles 
  // de pointeurs sur des villes ou des routes .
  
  public :

ENS();
virtual ~ENS();

virtual int hash(QString, int tailleTab) const;
virtual void inserer(type *) ;
virtual bool supprimer(type *) ;
virtual type* tete() const ; //permet d'utiliser la BD comme une liste.
virtual type* Suivant(type*) const;//idem .Renvoie NULL si a a echou ou si
 // en fin de liste.
virtual int Taille() const ;//renvoie le nombre total d'lements .
virtual bool Sauve(int);
virtual void ViderE();
typedef Cellule<type *>* Place;
};



#endif




