#include <qstring.h>
#include "routeVille.h"
#include "route.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "base.h"

Route::Route(){}

Route::Route(Ville* b, Ville* c)
{extrem1=b;
 extrem2=c;
extrem1->ajoutVoisin(this);
 extrem2->ajoutVoisin(this);}

Route::~Route() {
//extrem1->suppriVoisin(this);
//extrem2->suppriVoisin(this);
//delete extrem1;
//delete extrem2;
}

Ville* Route::retextrem1() const
{return extrem1;}

Ville* Route::retextrem2() const
{return extrem2;}

uniteDist Route::retLongueur() const
{return longueur;}

char Route::retType() const
{return type;}

void Route::modLongueur(uniteDist a)
{longueur=a;}

void Route::modType(char b)
{type=b;}

bool Route::estVille() const
{return false;}


bool Route::operator ==(const Route & R ) const
{if ((retNom()==R.retNom()) && (*retextrem1()==*R.retextrem1()) && (*retextrem2()==*R.retextrem2())) return true;
 else return false;}



bool Route::operator !=(const Route & R ) const
{if ((retNom()!=R.retNom()) || (*retextrem1()!=*R.retextrem1()) || (*retextrem2()!=*R.retextrem2())) return true;
 else return false;}





QString Route::rethash() const
{return (extrem1->retNom()+extrem2->retNom());}

bool Route::sauveRoutVille(int desc)
{QString a, b, c, d, e;
 QString lu=retNom()+""+b.setNum(extrem1->retx())+""+c.setNum(extrem1->rety())+""+d.setNum(extrem2->retx())+""+e.setNum(extrem2->rety())+""+a.setNum(retLongueur())+"";
 if ((write(desc , lu.data() , lu.length()))==-1) {return false;}
 char t=retType();
 if (write(desc , &t , 1)==-1) {return false;} 
 if ((write(desc , "" , 2))==-1) {return false;}
 else    {return true;}
}

bool Route::restitRoutVille(int descr,Base *bob)
{char Unchar;
 QString *n=new QString[7];
 if (read(descr,&Unchar,1)<=0) {return false;}
 for (int i=0;i<7;i++)
   {while (Unchar!='')
     {n[i]=n[i]+Unchar;
      if (read(descr,&Unchar,1)<=0) {return false;} 
     }
   if (read(descr,&Unchar,1)<=0) {return false;}
   }
 if (read(descr,&Unchar,1)<=0) {return false;}  
 modNom(n[0]);
 extrem1=bob->rechxy(n[1].toDouble(),n[2].toDouble());
 extrem2=bob->rechxy(n[3].toDouble(),n[4].toDouble());
 if (extrem1==NULL || extrem2==NULL) return false;
 modLongueur(n[5].toDouble());
 const char *w=n[6];
 modType(*w);
 return true;
}


Route& Route:: operator=(const Route& r)
{
modNom(r.retNom());
longueur=r.retLongueur();
extrem1=r.retextrem1();
extrem2=r.retextrem2();
type=r.retType();
}


uniteCoor Route::retx()const {}
uniteCoor Route::rety()const {}
void Route::modextrem1(Ville* v)
{ extrem1=v; }
void Route::modextrem2(Ville* v)
{ extrem2=v; }


void Route::affiche (QPainter* p, QColor c)
{
  p->setPen(c);
  p->drawLine(int(retextrem1()->retx()),int(retextrem1()->rety()),
             int(retextrem2()->retx()),int(retextrem2()->rety()));        
}
