#ifndef Route_h
#define Route_h
#include <qstring.h>
#include <qlist.h>
#include <qpainter.h>
#include "ville.h"
#include "routeVille.h"



#define uniteDist double
#define uniteCoor double

class Base;
class Ville;

class Route:virtual public RouteVille
{private:
 uniteDist longueur;
 Ville *extrem1;   //Pointeur sur une ville extrmit .
 Ville *extrem2;    //Pointeur sur l'autre ville extrmit .
 char type;         //n pour nationale, a pour autoroute, ...
 public:
 Route();
 Route(Ville*, Ville*);

 virtual ~Route();
 virtual Ville* retextrem1() const ;
 virtual Ville* retextrem2() const ;
 virtual uniteDist retLongueur() const ;
 virtual char retType() const ;
 virtual void modLongueur(uniteDist);
 virtual void modType(char);
 virtual bool estVille() const ; 
 virtual bool operator ==(const Route &) const ;
virtual bool operator !=(const Route &) const ;
 virtual QString rethash()const;
virtual bool sauveRoutVille(int desc);
virtual bool restitRoutVille(int descr,Base*);
virtual Route& operator=(const Route& );

virtual uniteCoor retx() const ;     // Pour pouvoir utiliser une pile de RouteVille avec des Routes et des Villes
virtual uniteCoor rety() const ;
virtual void modextrem1(Ville*);     // Pour modifier l'extrmit d'une route.
virtual void modextrem2(Ville*);     // Pour modifier l'extrmit d'une route.

virtual void sauve_defaire(int );    // Pour mettre dans la Pile de sauvegarde.

virtual void affiche (QPainter*, QColor c = blue); 

};

  

#endif
