#include "selection.h"

selection::selection() {}
selection::~selection() {}

void selection::inserer(Ville* v) {
  lv.insert(0,v);
}

void selection::inserer(Route* r){
  lr.insert(0,r);
}
 
Ville* selection::premiereVille() {
  return lv.first();
}

Route* selection::premiereRoute() {
  return lr.first();
}

Ville* selection::villeSuivante() {
  return lv.next();
}

Route* selection::routeSuivante(){
  return lr.next(); 
}

void selection::vider() {
  while (lv.first()!=NULL)
    lv.remove();
  while (lr.first()!=NULL)
    lr.remove();
}

void selection::supprimer(Ville* v) {
  lv.remove(v);
}

void selection::supprimer(Route* r) {
  lr.remove(r);
}

Ville* selection::villeCourante(){
  return lv.current();
}

Route* selection::routeCourante(){
  return lr.current();
}
