#ifndef UNDO_H
#define UNDO_H

#include <string>
#include <qlist.h>
#include "ville.h"
#include "base.h"

class Undo_Redo
{
 private:
  QList<RouteVille > *Pile_Undo;              // Pile de sauvegarde pour les Dfaires.
  QList<RouteVille > *Pile_Redo;              // Pile de sauvegarde pour les Refaires. (inutilise)
  const int nbre_def_ref = 5;                 // Nombre maximal de Dfaires possibles.

 public:
Undo_Redo();
virtual ~Undo_Redo();        
virtual QList<RouteVille> *getP_U();          // Accesseur sur la Pile de sauvegarde.
virtual QList<RouteVille> *getP_R();
virtual int countP_U();                       // Accesseur sur le nombre d'lments dans la Pile.
virtual int countP_R();
virtual int NbreMaxDefRef()const;             // Accesseur sur le nombre max de Dfaires.
};

#endif UNDO_H
