#ifndef Ville_h
#define Ville_h
#include <qlist.h>
#include <qstring.h>
#include <qpainter.h>

#include "tLidou.h"
#include "routeVille.h"
#include "route.h"


#define  uniteCoor double

class Base;
class Route;


class Ville : virtual public RouteVille
{
 private:

long population ;
int altitude ;
QString region,type ;
uniteCoor x,y;
ListeDouble< Route * > voisins; //Liste double de pointeurs sur les routes 
                               // dont cette ville est une extrmit .

 public:

Ville(uniteCoor a=0, uniteCoor b=0 );

virtual ~Ville();
virtual long retPop() const ;
virtual int retAlt() const ;
virtual QString retReg() const ;
virtual QString retTyp() const ;
virtual uniteCoor retx() const ;
virtual uniteCoor rety() const ;
virtual QList<Route> retVoisins();//Beaucoup de gens veulent une QList
// Voila qui est fait: c'est une QList de pointeurs sur les routes

virtual void modPop(long);
virtual void modAlt(int);
virtual void modReg(QString);
virtual void modTyp(QString);
virtual void modx(uniteCoor);
virtual void mody(uniteCoor);

virtual void ajoutVoisin(Route*); //utilis  la cration des routes.
virtual bool suppriVoisin(Route*); //utilis  la destruction des routes.

virtual bool operator ==(const Ville & ) const;
virtual bool operator !=(const Ville & ) const;

virtual QString rethash()const;
virtual bool estVille() const ;

virtual bool sauveRoutVille(int desc) ;//fonction de sauvegarde .
virtual bool restitRoutVille(int descr, Base* b=NULL) ;//fonction de recharge .
virtual Ville& operator= (const Ville&);
typedef Cellule<Route*>* Place;

virtual void sauve_defaire(int );
virtual void affiche (QPainter*, QColor c = red);  
};



#endif

