#include "fenresultat.h"
#include <string.h>
#include <stdio.h>


Resultat::Resultat(QList<Ville> l)
 : QListView()
{
   addColumn("Nom");
   addColumn("Coordonne X");
   addColumn("Coordonne Y");
   addColumn("Population");
   addColumn("Altitude");
   addColumn("Rgion");
   addColumn("Type");
   

   
   char x[40],y[40],pop[40],alt[40],typ[40];
    for(int i=0;i<l.count();i++)
     {  Ville *v=l.at(i);
        sprintf(x,"%f",v->retx());
        sprintf(y,"%f",v->rety());
        sprintf(pop,"%d",v->retPop());
        sprintf(alt,"%d",v->retAlt());

        switch (v->retTyp()[0])
        {case 'c':
           sprintf(typ,"capitale");
           break;
         case 'r':
           sprintf(typ,"capitale regionnale");
           break;
         case 'p':
           sprintf(typ,"prefecture");
           break;
         case 's':
           sprintf(typ,"sous prefecture");
           break;
         case 'b':
           sprintf(typ,"bled paume");
           break;
        }

        new QListViewItem(this,v->retNom(),x,y,pop,alt,v->retReg(),typ);
     }

}

Resultat::~Resultat(){}

ResDiag::ResDiag(QList<Ville> l) : QMainWindow()
{
   Resultat *res = new Resultat(l);
   
   char titre[100];
   if(l.count()<=1)
      sprintf(titre,"Resultat : %d ville trouve",l.count());
   else
      sprintf(titre,"Resultat : %d villes trouves",l.count());
   res->setCaption(titre);
   setCentralWidget( res );
   res->show();
}

ResDiag::~ResDiag(){}

