#include <qlist.h>

#include "ville.h"
#ifndef SELECTION_H
#define SELECTION_H

#include "route.h"

class selection {
 private:
  QList<Ville> lv;
  QList<Route> lr;
  
 public:
  selection();
  ~selection();
  void inserer(Ville*);
  void inserer(Route*);
  Ville* premiereVille();
  Route* premiereRoute();
  Ville* villeCourante();
  Route* routeCourante();
  
  Ville* villeSuivante();
  Route* routeSuivante();
  void supprimer(Ville*);
  void supprimer(Route*);
  void vider();
};

#endif
