#include <iostream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "ville.h"




Ville::Ville(uniteCoor a, uniteCoor b)
{
x=a;
y=b;
}



Ville::~Ville(){}

long Ville::retPop() const
{return population;}

int Ville::retAlt()const
{return altitude;}

QString Ville::retReg() const
{return region;}

QString Ville::retTyp() const
{return type ;}

uniteCoor Ville::retx()const {return x;}

uniteCoor Ville::rety()const {return y;}

QList<Route> Ville::retVoisins()
{QList<Route> list;
Place p=voisins.premier();
int i=0;
while(p!=NULL)
  {list.insert(i,voisins.valeur(p));
  p=voisins.suivant(p);
  i++;}
 return list;}

void Ville::modPop(long p)
{population=p;}

void Ville::modAlt(int a)
{altitude=a;}

void Ville::modReg(QString r)
{region=r;}

void Ville::modTyp(QString t)
{type=t;}

void Ville::modx(uniteCoor h)
{x=h;}

void Ville::mody(uniteCoor j)
{y=j;}

void Ville::ajoutVoisin(Route* r) {voisins.ajoutApres(voisins.premier(),r);}

bool Ville::suppriVoisin(Route* r) 
{Place p=voisins.recherche(r);  //On a rajout la fonction recherche
 if (p!=NULL)  {voisins.enleve(p); // dans tLidou.h et .cc   .
               return true;}
 else return false;}

bool Ville::estVille() const
{return true;}

bool Ville::operator ==(const Ville & V) const
{if ((x==V.retx()) && (y==V.rety())) return true;
 else return false;}

bool Ville::operator !=(const Ville & V) const
{if ((x!=V.retx()) || (y!=V.rety())) return true;
 else return false;}


QString Ville::rethash() const
{return retNom();}






bool Ville::sauveRoutVille(int desc) {
QString a, b, c, d;
QString lu=retNom()+""+retReg()+""+retTyp()+""+a.setNum(retx())+""+b.setNum(rety())+""+c.setNum(retPop())+""+d.setNum(retAlt())+""; //On crit les attributs.
if ((write(desc , lu.data() , lu.length()))==-1) {return false;}
else    {return true;}
}

bool Ville::restitRoutVille(int descr,Base* b)
{char Unchar;
 QString *n=new QString[7];
 if (read(descr,&Unchar,1)<=0) {return false;}
 for (int i=0;i<7;i++)
   {while (Unchar!='')
     {n[i]=n[i]+Unchar;
      if (read(descr,&Unchar,1)<=0) {return false;} 
     }
   if (read(descr,&Unchar,1)<=0) {return false;}
   }
 if (read(descr,&Unchar,1)<=0) {return false;}  
 modNom(n[0]);
 modReg(n[1]);
 modTyp(n[2]);
 modx(n[3].toDouble());
 mody(n[4].toDouble());
 modPop(n[5].toLong());
 modAlt(n[6].toInt());
 return true;
}


Ville& Ville:: operator=(const Ville& v)
{
modNom(v.retNom());
population=v.retPop();
altitude=v.retAlt();
region=v.retReg();
type=v.retTyp();
x=v.retx();
y=v.rety();
voisins=v.voisins;

}

void Ville::affiche (QPainter* p, QColor c)
{
  p->setPen(c);
  p->drawEllipse(int(retx()),int(rety()),5,5);     
}





